function XUB_DumpSpellList()
    local i = 1
    local spellName, spellRank
    while true do
       spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
       if not spellName then
          do break end
       end

       -- use spellName and spellRank here
       DEFAULT_CHAT_FRAME:AddMessage( spellName .. '(' .. spellRank .. ')' )

       i = i + 1
    end
end

function Debug(aWhat , aMessage)
    if XUB_DEBUG > 0 then
        if ( aMessage == nil ) then
            DEFAULT_CHAT_FRAME:AddMessage( aWhat .. " = NIL" );
        else
            DEFAULT_CHAT_FRAME:AddMessage( aWhat .. " = >" .. aMessage .. "<" );
        end
    end
end

function N(aArg)
    if ( aArg == nil ) then
        return "nil";
    else
        return aArg;
    end
end

function CCC(aArg)
    if ( aArg == nil ) then
        return "(nil)";
    elseif ( aArg == true ) then
        return "(true)";
    elseif ( aArg == false ) then
        return "(false)";
    else
        return "(" .. aArg .. ")";
    end
end

function DumpTable(aTable)
    for i=1,#aTable do
        Debug(i,aTable[i]);
    end
end

function ShowDebugMessage(MyString)
    if XUB_DEBUG >0 then
            ShowMessage(MyString);
    end
end

function XUB_Show_DebugBlock1(myButton, i, aUnit)
        if ( i==1 ) then
            ShowDebugMessage( "     ");
            ShowDebugMessage( "currently updated unit (aUnit): " .. aUnit );
        end
        ShowDebugMessage( "Buttonname : '" .. XUB_GenerateButtonName(aUnit,i) .. "'      FullSpellName: '" .. myButton.FullSpellName .. "'" )
end

function XUB_Show_DebugBlock2(myButton, i, aUnit, myPreviousState)

    ShowMessage( "currently updated unit (aUnit): " .. aUnit .. "           Buttonname : '" .. XUB_GenerateButtonName(aUnit,i) .. "'" )
    ShowMessage("myButton.PreviousState: "..myPreviousState.."   myButton.State: "..myButton.State);
    if myButton.Blink > 0 then
        ShowMessage("myButton.Blink: " .. myButton.Blink );
    end
    if myButton.MyCooldown > 0 then
        ShowMessage("myButton.MyCooldown: " .. myButton.MyCooldown );
    end
    ShowMessage("  ");
end

