﻿
function XUB_ConvertSaved()

    --Debug("XUB_ConvertSaved started");

    if XUB_ConversionLevel < 1.8 then

        --XUGConfigButtons --> XUB_ConfigButtons
        if XUGConfigButtons ~= nil then
            if XUB_ConfigButtons ~= nil then
            Debug("XUGConfigButtons:" .. #XUGConfigButtons);
            Debug("XUB_ConfigButtons:" .. #XUB_ConfigButtons);
            for btns=1, #XUGConfigButtons do
               local btn = XUGConfigButtons[btns];
               Debug("Button[" .. btns .. "]:".. btn[1]);
               table.insert(XUB_ConfigButtons,btn);
            end
            XUGConfigButtons = {};
            else
            end
        end

        --XUGConfigGroups --> XUB_ConfigGroups
        if XUGConfigGroups ~= nil then
            if XUB_ConfigGroups ~= nil then
            Debug("XUGConfigGroups:" .. #XUGConfigGroups);
            for grps=1, #XUGConfigGroups do
               local grp = XUGConfigGroups[grps];
               Debug("Group[" .. grps .. "]:".. grp[1]);
               table.insert(XUB_ConfigGroups,grp);
            end
            XUGConfigGroups= {};
            else
            end
          end

        --XUGConfigProfiles --> XUB_ConfigProfiles
        if XUGConfigProfiles ~= nil then
            if XUB_ConfigProfiles ~= nil then
            Debug("XUGConfigProfiles:" .. #XUGConfigProfiles);
            for prfs=1, #XUGConfigProfiles do
               local prf = XUGConfigProfiles[prfs];
               Debug("Profile[" .. prfs .. "]:".. prf[1]);
               table.insert(XUB_ConfigProfiles,prf);
            end
            XUGConfigProfiles = {};
            else
            end
        end

        --XUGCurrentProfile --> XUB_CurrentProfile
        if XUGCurrentProfile ~= nil then
            if XUGCurrentProfile ~= "" then
                if XUB_CurrentProfile ~= nil then
                   Debug("XUGCCurrentProfile:" .. XUGCurrentProfile);
                   XUB_CurrentProfile = XUGCurrentProfile;
                   XUGCurrentProfile = "";
                else
                end
            end
        end

        --XUBBLINKRATE --> XUB_BLINKRATE
        if XUBBLINKRATE ~= nil then
            if XUBBLINKRATE ~= -1 then
                if XUB_BLINKRATE ~= nil then
                    Debug("XUBBLINKRATE:" .. XUBBLINKRATE);
                    XUB_BLINKRATE = XUBBLINKRATE;
                    XUBBLINKRATE = -1;
                else
                    Debug("XUB_BLINKRATE:" .. XUB_BLINKRATE);
                end
            end
        end

        if ( XUB_HEALACTION == "Hide and Disable" ) then
            XUB_HEALACTION = "Show as Disabled";
        elseif ( XUB_HEALACTION == "Buffed and Enabled" ) then
           XUB_HEALACTION = "Show as Buffed";
        elseif (XUB_HEALACTION == "Show as Disabled" ) then
        elseif (XUB_HEALACTION == "Show as Buffed" ) then
	    else
           XUB_HEALACTION = "Show as Buffed";
        end
        XUB_OptionsHealActionText:SetText(XUB_HEALACTION);

        if ( XUB_COLORUSAGE == "Red Cooldown/Blue Mana" ) then
            XUB_COLORUSAGE = "Color Coded";
            XUB_OptionsColorUsageText:SetText(XUB_COLORUSAGE);
        end

        if ( XUB_ALWAYS_SHOW_COOLDOWN == 1 ) then
            XUB_TOOLTIPS = "Show Cooldown Even In Combat";
            XUB_OptionsToolTipOptionText:SetText(XUB_TOOLTIPS);
        end

        XUB_ALWAYS_SHOW_COOLDOWN = nil;

        XUB_ConversionLevel = 1.8

    end  -- conversion level < 1.8

    if XUB_ConversionLevel < 1.9 then
        XUB_UseRightButton = "RightButtonUp"
        XUB_UseMiddleButton = "MiddleButtonUp"
        XUB_UseButton4 = "Button4Up"
        XUB_UseButton5 = "Button5Up"
        XUB_USE_NEWGROUPCHECK = 1;


--[[ code for future conversion of all normal buttons into custom buttons type 'spell'

        local already_a_custom_spell = nil;
        local SpellName_from_Groups, SpellName_from_CustomButtons
        local myNewCB = { }
        
        for i =1,#XUB_ConfigGroups do
            SpellName_from_Groups = XUB_ConfigGroups[i][2]
            for j =1,#XUB_ConfigButtons do
                CB_name = XUB_ConfigButtons[j][1];
                if ( SpellName_from_Groups == SpellName_from_CustomButtons ) then
                    already_a_custom_spell = true;
                end
            end
            --    if the spellname does not refer to an existing custom button then add it as a custom button type 'spell'
            if ( already_a_custom_spell == nil) then
            
                myNewCB = { }
                
                -- let's prefix the original spellname to show it's custom button
                --XUB_ConfigGroups[i][2] = "CB_" .. SpellName_from_Groups;
                myNewCB[1] = XUB_ConfigGroups[i][2];
                myNewCB[2] = "spell";
                myNewCB[3] = SpellName_from_Groups;
                myNewCB[4] = "";
                table.insert(XUB_ConfigButtons, myNewCB);
            end
        end
]]

        XUB_ConversionLevel = 1.9

    end  -- conversion level < 1.9

    Debug("XUB_ConvertSaved finished");

end

