



--

-- This function identifies the first 9 spells in a players spell box

-- and initializes the rest of the form.

--

function XUB_SM_OnShow()

	XUB_SelectMacroSliderSlider:SetMinMaxValues(1,GetNumMacroIcons()-40);

	XUB_SelectMacroSliderSlider:SetValue(1);

	XUB_SM_ShowMacros(1);

end



function XUB_SM_ShowMacros(aIndex)

	for i=0,39 do

		XUB_SM_ShowAMacro(i+1,aIndex+i);

	end

end



function XUB_SM_ShowAMacro(aPosition,aMacroID)



	local myTexture = getglobal("XUB_SelectMacroTexture" .. aPosition .. "Texture" );



	myTexture:SetTexture( GetMacroIconInfo(aMacroID) );



	if ( XUB_SM_SelectedMacro == aMacroID ) then

		myTexture:SetTexture( GetMacroIconInfo(aMacroID) );

	end

	

end



function XUB_SM_OnValueChanged()

	XUB_SM_ShowMacros(XUB_SelectMacroSliderSlider:GetValue());

end



function XUB_SM_SetMacro(aPosition)

	local mySelectedTexture = getglobal("XUB_SelectMacroTexture0Texture" );

	XUB_SM_SelectedMacro = XUB_SelectMacroSliderSlider:GetValue() + aPosition - 1;

	mySelectedTexture:SetTexture( GetMacroIconInfo(XUB_SM_SelectedMacro) );

	

	-- Temporary

	XUB_SelectMacroComponent1Label:SetText( "Selected Macro (#" .. XUB_SM_SelectedMacro .. "):" );

end