﻿-- XUB_UNITFRAMES = XUB_OptionsUnitFramesText:GetText();
-- XUB_OptionsUnitFramesText:SetText(XUB_UNITFRAMES);

function XUB_UF_ApplyDefault()

    local myDefault = XUB_UnitFramesDefaultsText:GetText();

    if ( myDefault == "agUnitFrames" ) then
        XUB_UF_Apply( "Player" , "aUFplayer" );
		XUB_UF_Apply( "PlayerPet" , "aUFpet" );
		XUB_UF_Apply( "Party" , "aUFpartyUnitButton#" );
		XUB_UF_Apply( "PartyPet" , "aUFpartypetUnitButton#" );
		XUB_UF_Apply( "Target" , "aUFtarget" );
		XUB_UF_Apply( "Focus" , "aUFfocus" );
	elseif ( myDefault == "Blizzard" ) then
        XUB_UF_Apply( "Player" , "PlayerFrame" );
		XUB_UF_Apply( "PlayerPet" , "PetFrame" );
		XUB_UF_Apply( "Party" , "PartyMemberFrame#" );
		XUB_UF_Apply( "PartyPet" , "PartyMemberFrame#PetFrame" );
		XUB_UF_Apply( "Target" , "TargetFrame" );
		XUB_UF_Apply( "Focus" , "FocusFrame" );
	elseif ( myDefault == "XPerl" ) then
        XUB_UF_Apply( "Player" , "XPerl_Player" );
		XUB_UF_Apply( "PlayerPet" , "XPerl_Player_Pet" );
		XUB_UF_Apply( "Party" , "XPerl_party#" );
		XUB_UF_Apply( "PartyPet" , "XPerl_partypet#" );
		XUB_UF_Apply( "Target" , "XPerl_Target" );
		XUB_UF_Apply( "Focus" , "XPerl_Focus" );
	elseif ( myDefault == "Discord Unit Frames" ) then
        XUB_UF_Apply( "Player" , "DUF_PlayerFrame" );
		XUB_UF_Apply( "PlayerPet" , "DUF_PetFrame" );
		XUB_UF_Apply( "Party" , "DUF_PartyFrame#" );
		XUB_UF_Apply( "PartyPet" , "DUF_PartyPetFrame#" );
		XUB_UF_Apply( "Target" , "DUF_TargetFrame" );
		XUB_UF_Apply( "Focus" , "DUF_FocusFrame" );
	elseif ( myDefault == "Perl Classic Frames" ) then
        XUB_UF_Apply( "Player" , "Perl_Player_Frame" );
        XUB_UF_Apply( "PlayerPet" , "Perl_Player_Pet_Frame" );
        XUB_UF_Apply( "Party" , "Perl_Party_MemberFrame#" );
        XUB_UF_Apply( "PartyPet" , "Perl_Party_Pet#" );
        XUB_UF_Apply( "Target" , "Perl_Target_Frame" );
        XUB_UF_Apply( "Focus" , "Perl_Focus_Frame" );
--        XUB_UF_Apply( "1" , "Perl_Target_Target_Frame" );
    elseif ( myDefault == "Sage" ) then
        XUB_UF_Apply( "Player" , "Sageplayer" );
        XUB_UF_Apply( "PlayerPet" , "Sagepet" );
        XUB_UF_Apply( "Party" , "Sageparty#" );
        XUB_UF_Apply( "PartyPet" , "Sagepartypet#" );
        XUB_UF_Apply( "Target" , "Sagetarget" );
        XUB_UF_Apply( "Focus" , "Sagefocus" );
    elseif ( myDefault == "Sage only" ) then
        XUB_UF_Apply( "Player" , "player" );
        XUB_UF_Apply( "PlayerPet" , "pet" );
        XUB_UF_Apply( "Party" , "party#" );
        XUB_UF_Apply( "PartyPet" , "partypet#" );
        XUB_UF_Apply( "Target" , "target" );
        XUB_UF_Apply( "Focus" , "focus" );
    elseif ( myDefault == "SageFrame" ) then
        XUB_UF_Apply( "Player" , "SageFrameplayer" );
        XUB_UF_Apply( "PlayerPet" , "SageFramepet" );
        XUB_UF_Apply( "Party" , "SageFrameparty#" );
        XUB_UF_Apply( "PartyPet" , "SageFramepartypet#" );
        XUB_UF_Apply( "Target" , "SageFrametarget" );
        XUB_UF_Apply( "Focus" , "SageFramefocus" );
    elseif ( myDefault == "SageClick" ) then
        XUB_UF_Apply( "Player" , "SageClickplayer" );
        XUB_UF_Apply( "PlayerPet" , "SageClickpet" );
        XUB_UF_Apply( "Party" , "SageClickparty#" );
        XUB_UF_Apply( "PartyPet" , "SageClickpartypet#" );
        XUB_UF_Apply( "Target" , "SageClicktarget" );
        XUB_UF_Apply( "Focus" , "SageClickfocus" );
    elseif ( myDefault == "PitBull" ) then
        XUB_UF_Apply( "Player" , "PitBullUnitFrame1" );
        XUB_UF_Apply( "PlayerPet" , "PitBullUnitFrame2" );
        XUB_UF_Apply( "Party" , "PitBullCluster2UnitButton#" );
        XUB_UF_Apply( "PartyPet" , "PitBullCluster3UnitButton#" );
        XUB_UF_Apply( "Target" , "PitBullUnitFrame4" );
        XUB_UF_Apply( "Focus" , "PitBullUnitFrame6" );
    end

end

function XUB_UF_Apply( aUnit , aUnitFrameName )
    local myText = getglobal( "XUB_UnitFrames" .. aUnit );
    myText:SetText(aUnitFrameName);
end

function XUB_UF_Refresh( aUnit )
    local mySaveVar = getglobal( "XUB_UF_" .. aUnit );
    local myText = getglobal( "XUB_UnitFrames" .. aUnit );
    myText:SetText(mySaveVar);

    local mySaveVar = getglobal( "XUB_UF_WIDTH_" .. aUnit );
    local myText = getglobal( "XUB_UnitFrames" .. aUnit .. "WidthLabel" );
    myText:SetText(mySaveVar);
end

function XUB_UF_RefreshCustom( aUnit )
    local mySaveVar = getglobal( "XUB_UF_CUSTOMNAME" .. aUnit );
    local myText = getglobal( "XUB_UnitFramesCustom" .. aUnit .. "Name" );
    myText:SetText(mySaveVar);

    local mySaveVar = getglobal( "XUB_UF_CUSTOMFRAME" .. aUnit );
    local myText = getglobal( "XUB_UnitFramesCustom" .. aUnit .. "Frame" );
    myText:SetText(mySaveVar);

    local mySaveVar = getglobal( "XUB_UF_CUSTOMWIDTH" .. aUnit );
    local myText = getglobal( "XUB_UnitFramesCustom" .. aUnit .. "WidthLabel" );
    myText:SetText(mySaveVar);
end

function XUB_UF_RefreshScreenFromSave()
    XUB_UF_Refresh( "Player" );
	XUB_UF_Refresh( "PlayerPet" );
	XUB_UF_Refresh( "Party" );
	XUB_UF_Refresh( "PartyPet" );
	XUB_UF_Refresh( "Target" );
	XUB_UF_Refresh( "Focus" );

    XUB_UF_RefreshCustom( "1" );
    XUB_UF_RefreshCustom( "2" );
    XUB_UF_RefreshCustom( "3" );
    XUB_UF_RefreshCustom( "4" );
    XUB_UF_RefreshCustom( "5" );

    XUB_UnitFramesDefaultsText:SetText(XUB_UF_DropDownDefault);
    XUB_UnitFramesRaidModText:SetText(XUB_UF_RaidFrames);

    getglobal("XUB_UnitFramesRaidMemberWidthLabel"):SetText(XUB_UF_WIDTH_RaidMember);
    getglobal("XUB_UnitFramesRaidPetWidthLabel"):SetText(XUB_UF_WIDTH_RaidPet);
end

function XUB_UF_SaveScreen()
    XUB_UF_SaveText( "Player" );
	XUB_UF_SaveText( "PlayerPet" );
	XUB_UF_SaveText( "Party" );
	XUB_UF_SaveText( "PartyPet" );
	XUB_UF_SaveText( "Target" );
	XUB_UF_SaveText( "Focus" );

    XUB_UF_SaveCustomText( "1" );
    XUB_UF_SaveCustomText( "2" );
    XUB_UF_SaveCustomText( "3" );
    XUB_UF_SaveCustomText( "4" );
    XUB_UF_SaveCustomText( "5" );

    XUB_UF_DropDownDefault = XUB_UnitFramesDefaultsText:GetText();
    XUB_UF_RaidFrames = XUB_UnitFramesRaidModText:GetText();

    ShowMessage("XUB Unit frames: " .. XUB_UF_DropDownDefault);
    ShowMessage("XUB Raid frames: " .. XUB_UF_RaidFrames);

    XUB_UF_WIDTH_RaidMember = getglobal("XUB_UnitFramesRaidMemberWidthLabel"):GetText();
    XUB_UF_WIDTH_RaidPet    = getglobal("XUB_UnitFramesRaidPetWidthLabel"):GetText();
end

function XUB_UF_SaveText( aUnit )
    local myTextField = getglobal( "XUB_UnitFrames" .. aUnit );
    local aUnitFrameName = myTextField:GetText();
    setglobal( "XUB_UF_" .. aUnit , aUnitFrameName );

    local myTextField = getglobal( "XUB_UnitFrames" .. aUnit .. "WidthLabel" );
    local aUnitButtonWidth = myTextField:GetText();
    setglobal( "XUB_UF_WIDTH_" .. aUnit , aUnitButtonWidth );
end

function XUB_UF_SaveCustomText( aUnit )
    local myTextField = getglobal( "XUB_UnitFramesCustom" .. aUnit .. "Name" );
    local aUnitFrameName = myTextField:GetText();
    setglobal( "XUB_UF_CUSTOMNAME" .. aUnit , aUnitFrameName );

    local myTextField = getglobal( "XUB_UnitFramesCustom" .. aUnit .. "Frame" );
    local aUnitFrameName = myTextField:GetText();
    setglobal( "XUB_UF_CUSTOMFRAME" .. aUnit , aUnitFrameName );

    local myTextField = getglobal( "XUB_UnitFramesCustom" .. aUnit .. "WidthLabel" );
    local aUnitButtonWidth = myTextField:GetText();
    setglobal( "XUB_UF_CUSTOMWIDTH" .. aUnit , aUnitButtonWidth );
end


function XUB_UF_Scroll(aUnit,arg1)
    local myTextField = getglobal( "XUB_UnitFrames" .. aUnit .. "WidthLabel" );
    local NUM = tonumber(myTextField:GetText()) + arg1;
    if ( NUM < 5 ) then
        NUM = 5;
    end
    myTextField:SetText(NUM);
end
